globalvar TITAN;
TITAN = id;

// SPRITES
TITAN.TitanArmDownS = sprite_add(directory + '/TitanArmDownS.png', 2, false, false, 0, 0);
TITAN.TitanGibsS = sprite_add(directory + '/TitanGibsS.png', 6, false, false, 22, 20);
TITAN.DeadRedTitanS = sprite_add(directory + '/DeadRedTitanS.png', 5, false, false, 64, 40);
TITAN.DeadBlueTitanS = sprite_add(directory + '/DeadBlueTitanS.png', 5, false, false, 64, 40);
TITAN.DeadTitan2S = sprite_add(directory + '/DeadTitan2S.png', 32, false, false, 64, 230);
TITAN.TitanBottomS = sprite_add(directory + '/TitanBottomS.png', 2, false, false, 64, 102);
TITAN.TitanFrameS = sprite_add(directory + '/TitanFrameS.png', 6, false, false, 64, 102);
TITAN.TitanJumpS = sprite_add(directory + '/TitanJumpS.png', 12, false, false, 64, 88);
TITAN.StaticWindowS = sprite_add(directory + '/StaticWindowS.png', 9, false, false, 0, 0);
TITAN.ClassWindowS = sprite_add(directory + '/ClassWindowS.png', 20, false, false, 0, 0);
TITAN.CountdownWindowS = sprite_add(directory + '/CountdownWindowS.png', 18, false, false, 0, 0);
TITAN.TitanLaserFS = sprite_add(directory + '/TitanLaserFS.png', 6, false, false, 13, 9);
TITAN.TitanMachinegunFS = sprite_add(directory + '/TitanMachinegunFS.png', 6, false, false, 13, 9);
TITAN.TitanMachinegunS = sprite_add(directory + '/TitanMachinegunS.png', 2, false, false, 13, 9);
TITAN.TitanMaskS = sprite_add(directory + '/TitanMaskS.png', 1, false, false, 64, 104);
TITAN.DeadTitanMaskS = sprite_add(directory + '/DeadTitanMaskS.png', 1, false, false, 32, 226);

// Make the gib collison less shit
sprite_collision_mask(TITAN.TitanGibsS, 0, 2, 16, 16, 25, 25, 2, 0);

// CONTROLS
// Add a button configuration to the menu
object_event_add(AdvControlsController, ev_create, 0, "
    menu_addedit_key('Board/exit (titans):', 'TITAN.BoardingButton');
");

object_event_add(AdvControlsController, ev_destroy, 0, "
    ini_open('controls.gg2');
    ini_write_real('Controls', 'TitanBoarding', TITAN.BoardingButton);
    ini_close();
");

ini_open("controls.gg2");
TITAN.BoardingButton = ini_read_real("Controls", "TitanBoarding", ord("Q"));
ini_close();

// CONSTANTS
TITAN.KEYPRESS = 1;
TITAN.MOUNT = 2;
TITAN.DISMOUNT = 3;
TITAN.EXPLODE = 4;
TITAN.SPAWN = 5;

// LIST
TITAN.list = ds_list_create();

// Script to turn a character into a titan (arg0 = character, arg1 = titanHp)
TITAN.titanize = "
    with(argument0) {
        if (isTitan) {
            exit;
        }
        isTitan = true;

        oldWeapon = currentWeapon;
        oldWeapon.readyToShoot = false;
        oldWeapon.visible = false;
        oldRunPower = runPower;
        oldbasemaxspeed = basemaxspeed;
        oldHp = hp;
        oldMaxHp = maxHp;
        oldSprite = sprite_index;
        oldCapStrength = capStrength;
        oldCanDoublejump = canDoublejump;

        runPower = 0.8;
        basemaxspeed = abs(runPower * baseControl / (baseFriction-1));
        maxHp = 100;
        hp = argument1;
        prevHp = hp;
        sprite_index = TITAN.TitanMaskS;
        capStrength = 0;
        canDoublejump = false;

        global.paramOwner = id;
        currentWeapon = instance_create(x, y, TITAN.TitanGun);
        global.paramOwner = noone;

        if (intel) {
            doEventDropIntel(player);
        }
    }
";

// Script to turn a titan into a character (arg0 = titan)
TITAN.detitanize = "
    with(argument0) {
        if (!isTitan) {
            exit;
        }
        isTitan = false;

        with(currentWeapon)
            instance_destroy();
        currentWeapon = oldWeapon;
        currentWeapon.readyToShoot = true;
        currentWeapon.visible = true;
        runPower = oldRunPower;
        basemaxspeed = oldbasemaxspeed;
        hp = oldHp;
        maxHp = oldMaxHp;
        sprite_index = oldSprite;
        capStrength = oldCapStrength;
        canDoublejump = oldCanDoublejump;
        cloak = false;
    }
";

// Script that blows up a titan (arg0 = object that blows up)
TITAN.destroyTitan = "
    with(argument0) {
        explosionDamage = 200;
        blastRadius = 100;
        affectRadius = 120;
        splashThreshhold = true; // whether to cap the distance at which splash has an effect
        knockback = 10;
        reflector = noone;
        if (object_is_ancestor(object_index, Character)) {
            ownerPlayer = player;
        } else {
            ownerPlayer = noone;
        }

        with (Character) {
            if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.id and place_meeting(x, y+1, Obstacle)))
            {
                var rdir, vectorfactor;
                rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
                vectorfactor = point_distance(0, 0, sin(degtorad(rdir)), cos(degtorad(rdir))*0.8);
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) // skip if we're out of theshhold
                    continue;
                motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
                if((other.team != team or id==other.id) and !ubered and hp > 0)
                {
                    var dmg;
                    dmg = other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius));
                    damageCharacter(other.ownerPlayer, id, dmg);
                    timeUnscathed = 0;
                    if (id == other.id and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer and !instance_exists(other.reflector))
                        lastDamageSource = DAMAGE_SOURCE_FINISHED_OFF_GIB;
                    else
                    {
                        if (lastDamageDealer != other.ownerPlayer and lastDamageDealer != player and other.reflector != lastDamageDealer)
                        {
                            secondToLastDamageDealer = lastDamageDealer;
                            alarm[4] = alarm[3]
                        }
                        if (other.ownerPlayer != id or (instance_exists(other.reflector) and other.ownerPlayer == id))
                            alarm[3] = ASSIST_TIME;
                        lastDamageDealer = other.ownerPlayer;
                        lastDamageSource = DAMAGE_SOURCE_GENERATOR_EXPLOSION;
                        if (id==other.id and instance_exists(other.reflector))
                        {
                            lastDamageDealer = other.reflector;
                            lastDamageSource = DAMAGE_SOURCE_GENERATOR_EXPLOSION;
                        }
                    }
                    if(global.gibLevel > 0)
                    {
                        repeat(3)
                        {
                            var blood;
                            blood = instance_create(x,y,Blood);
                            blood.direction = point_direction(other.x,other.y,x,y)-180;
                        }
                    }
                    if (id==other.id)
                        moveStatus = 1;
                    else if (other.team == team)
                        moveStatus = 2;
                    else
                        moveStatus = 4;
                }
                cloakAlpha = max(cloakAlpha, 0.3);
                cloakFlicker = true;
                alarm[7] = 3;
            }
        }

        with (Sentry)
        {
            if (distance_to_object(other) < other.blastRadius) and (team != other.team)
            {
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) // skip if we're out of theshhold
                    continue;
                damageSentry(other.ownerPlayer, id, other.explosionDamage*3/2*(1-(distance_to_object(other)/other.blastRadius))); // we want sentries to take ~11% extra damage so that two stickies will do 100 instead of 90 dmg. we don't change the base damage so scouts can't be 2-hitted.
                lastDamageDealer = other.ownerPlayer;
                lastDamageSource = DAMAGE_SOURCE_GENERATOR_EXPLOSION;
            }
        }

         with (Generator)
         {
            if( (distance_to_object(other) < other.blastRadius) and (team != other.team) )
            {
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) // skip if we're out of theshhold
                    continue;
                damageGenerator(other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)));
            }
        }

        with (Rocket)
        {
            if (distance_to_object(other) < other.affectRadius * 0.75
                and (other.team != team or other.ownerPlayer == ownerPlayer))
            {
                if(distance_to_object(other) < other.affectRadius * 0.25)
                {
                    characterHit = -1;
                    event_user(5);
                }
                else
                {
                    motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/(other.affectRadius)));
                }
            }
        }

        with (DeadGuy)
        {
            if (distance_to_object(other) < other.affectRadius * 0.75)
            {
                motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.affectRadius));
            }
        }

        with(Mine) {
            if (distance_to_object(other) < other.blastRadius
                and (other.team != team or other.ownerPlayer == ownerPlayer))
            {
                if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) // skip if we're out of theshhold
                    continue;
                event_user(2);
            }
        }
        with (Gib)
        {
            if (distance_to_object(other) < other.affectRadius * 0.75)
            {
                motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.affectRadius));
                rotspeed=random(151)-75;
            }
        }

        with(LooseSheet)
        {
            if (distance_to_object(other) < other.affectRadius * 0.75)
                motion_add(point_direction(other.x, other.y, x, y)
                          ,10-10*(distance_to_object(other)/other.affectRadius));

        }

        // Handle bubbles

        with(Bubble)
        {
            if (point_distance(x, y, other.x, other.y) < other.blastRadius + selfPopRadius)
                instance_destroy();
        }

         if (object_is_ancestor(object_index, Character)) {
            with(player.corpse)
               instance_destroy();
        }

        playsound(x,y,ExplosionSnd);
        playsound(x,y,RevolverSnd);
        playsound(x,y,CPBeginCapSnd);
        if (random(1) > 0) { // Collision detecting in gm is bullshit
            instance_create(x-20, y-70, Explosion);
            instance_create(x+20, y-20, Explosion);
            instance_create(x+5, y+10, Explosion);

            var gib, i, body;
            body = instance_create(x, y-5, DeadGuy);
            if (team == TEAM_RED) {
                body.sprite_index = TITAN.DeadRedTitanS;
            } else {
                body.sprite_index = TITAN.DeadBlueTitanS;
            }

            body.image_speed = 0.25 * global.delta_factor;
            body.image_xscale = image_xscale;

            for (i=0; i<6; i+=1) {
                gib = instance_create(x, y, Accesory);
                gib.hspeed = (hspeed+random_range(-8,9));
                gib.vspeed = (vspeed+random_range(-8,9));
                gib.rotspeed = random(145)-72;
                gib.sprite_index = TITAN.TitanGibsS;
                gib.image_index = i;
            }
        } else {
            var body;
            body = instance_create(x, y-5, TITAN.DeadTitan);
            body.sprite_index = TITAN.DeadTitan2S;
            body.team = team;
            body.image_index = team * 16;
            body.endFrame = 16 + team * 16;
            body.startFrame = image_index;
            body.image_speed = 0.25 * global.delta_factor;
            body.image_xscale = image_xscale;
        }
    }
";

// Damage API (titan only take 10% damage so it seems like they have 1000 hp instead of 100)
global.dealDamageFunction += "
     if (object_is_ancestor(argument1.object_index, Character) || argument1.object_index == TITAN.Titan) {
        if (argument1.isTitan) {
            // Do it like this because argument2 is not reliable in the case of garrisonnauts being loaded for example.
            argument1.hp += (argument1.prevHp - argument1.hp) * 0.9;
            argument1.prevHp = argument1.hp;
        }
    }
";

// PLAYER
object_event_add(Player, ev_create, 0, "
    if (global.isHost) {
        alarm[1] = 1;
    }
");
object_event_add(Player, ev_alarm, 1, "
    var buffer;
    with(TITAN.Titan) {
        buffer = buffer_create();
        write_ubyte(buffer, TITAN.SPAWN);
        write_ushort(buffer, x*5);
        write_ushort(buffer, y*5);
        write_byte(buffer, image_xscale);
        write_ubyte(buffer, hp);
        write_ubyte(buffer, team);
        PluginPacketSendTo(TITAN.packetID, buffer, other.id);
        buffer_destroy(buffer);
    }
");

// CHARACTER
object_event_add(Character, ev_create, 0, "
    oldDeaths = player.stats[DEATHS];
    isTitan = false;
    jumping = false;

    staticIdx = 0;
    jumpIdx = 0;
");

object_event_add(Character, ev_destroy, 0, "
    if (oldDeaths + 1 == player.stats[DEATHS] && other.isTitan) {
        execute_string(TITAN.destroyTitan, id);
    }
");

object_event_add(Character, ev_step, ev_step_begin, "
    if (isTitan) {
        // jump detection
        if (!wantToJump and vspeed == -jumpStrength and moveStatus == 0) {
            jumping = true;
        }

        // Thou shall not zoom
        zoomed = false;

        // Cheat so titan can't pick up the intel :^)
        cloak = true;

        if(global.particles == PARTICLES_NORMAL) {
            if (random(1) > 0.95) {
                effect_create_below(ef_smokeup, x - 24*image_xscale, y - 78, 0, c_gray);
            }
            if (random(1) > 0.95) {
                effect_create_below(ef_smokeup, x + 2*image_xscale, y - 78, 0, c_gray);
            }
        }
    }
");

object_event_add(Character, ev_step, ev_step_end, "
    if (isTitan) {
        cloakAlpha = 0;
        omnomnomnom = false;
        taunting = false;
        runPower = 0.8;

        staticIdx = (staticIdx + 0.15 * global.delta_factor) mod 6;

        if (jumping) {
            jumpIdx += 0.75 * global.delta_factor;
            if (jumpIdx >= 6) {
                jumping = false;
                jumpIdx = 0;
            }
        }
    }
");

object_event_add(Character, ev_draw, 0, "
    if (isTitan) {
        var xr, yr;
        xr = round(x);
        yr = round(y);

        draw_sprite_ext(TITAN.TitanFrameS, player.team*3 + 2 - round(hp/maxHp*2), xr, yr, image_xscale, image_yscale, 0, c_white, 1);
        if (!jumping) {
            draw_sprite_ext(TITAN.TitanBottomS, player.team, xr, yr, image_xscale, image_yscale, 0, c_white, 1);
        } else {
            draw_sprite_ext(TITAN.TitanJumpS, player.team*6 + floor(jumpIdx), xr, yr, image_xscale, image_yscale, 0, c_white, 1);
        }

        if (hp > 20) {
            draw_sprite_ext(TITAN.ClassWindowS, player.class + player.team*10, xr - 16*image_xscale, yr-56, image_xscale, image_yscale, 0, c_white, 1);
        } else {
            draw_sprite_ext(TITAN.StaticWindowS, staticIdx, xr - 16*image_xscale, yr-56, image_xscale, image_yscale, 0, c_white, 1);
        }
    }
");

// Sync titan state
object_event_add(Character, ev_other, ev_user12, "
    if(global.updateType == FULL_UPDATE){
        write_ubyte(global.serializeBuffer, isTitan);
    }
");

object_event_add(Character, ev_other, ev_user13, "
    if(global.updateType == FULL_UPDATE){
        receiveCompleteMessage(global.serverSocket, 1, global.deserializeBuffer);
        if (read_ubyte(global.deserializeBuffer)) {
            execute_string(TITAN.titanize, id, hp);
            isTitan = true;
        }
    }
");

// GUN
TITAN.TitanGun = object_add();
object_set_parent(TITAN.TitanGun, Weapon);
object_set_depth(TITAN.TitanGun, -1);

object_event_add(TITAN.TitanGun, ev_create, 0, "
    xoffset = -19;
    yoffset = -37;
    refireTime = 3;
    event_inherited();

    sndlooping = false;
    maxAmmo = 200;
    ammoCount = 0;
    alarm[5] = 1;
    reloadBuffer = 10;
    isRefilling = false;
    reloadTime = 1;
    reloadTime2 = 30;
    mode = 0;
    hitDamage = 100;

    normalSprite = TITAN.TitanMachinegunS;
    recoilSprite[0] = TITAN.TitanMachinegunFS;
    recoilSprite[1] = TITAN.TitanLaserFS;
    reloadSprite = -1;

    sprite_index = normalSprite;

    //play at least 2 frames
    recoilTime = 3;
    recoilAnimLength = sprite_get_number(recoilSprite[0])/2;
    recoilImageSpeed = recoilAnimLength/recoilTime;

    tracerAlpha = 0;

    selfDamage = 150;
    uberCharge = 0;
    t = 0;
    healTarget = noone;
    lobbed = 0;
    readyToStab = false;
    baseDamage = 100;
");

object_event_add(TITAN.TitanGun, ev_alarm, 5, "
    isRefilling = true;
");

object_event_add(TITAN.TitanGun, ev_alarm, 6, "
    //Reset the sprite
    sprite_index = normalSprite;
    image_speed = 0;
");

object_event_add(TITAN.TitanGun, ev_step, ev_step_begin, "
    if (ammoCount < 0)
        ammoCount = 0;
    else if (ammoCount <= maxAmmo and isRefilling)
        ammoCount += 1 * global.delta_factor;
    if(!readyToShoot and alarm[5] < 25 and !isRefilling)
        alarm[5] += 1;
");

object_event_add(TITAN.TitanGun, ev_step, ev_step_end, "
    if(!instance_exists(TITAN.TitanHud))
        instance_create(0, 0, TITAN.TitanHud);

    if (justShot)
    {
        justShot = false;
        //Recoil Animation
        if (sprite_index != recoilSprite[mode])
        {
            sprite_index = recoilSprite[mode];
            image_index = 0;
            image_speed = recoilImageSpeed * global.delta_factor;
        }
        alarm[6] = recoilTime / global.delta_factor;
    }
");

object_event_add(TITAN.TitanGun, ev_other, ev_user1, "
    mode = 0;

    // prevent sputtering
    if (ammoCount < 2)
        ammoCount -= 2;
    if(readyToShoot and ammoCount >= 2)
    {
        playsound(x,y,ChaingunSnd);
        var shot, shotx, shoty;
        randomize();

        shotx = x+lengthdir_x(20,owner.aimDirection);
        shoty = y-14+lengthdir_y(20,owner.aimDirection)
        shot = createShot(shotx, shoty, Shot, DAMAGE_SOURCE_MINIGUN, owner.aimDirection+(random(14)-7), 12+random(1))
        shot.hspeed += owner.hspeed;
        shot.alarm[0] = 30 / global.delta_factor;
        shot.hitDamage = 9;

        justShot=true;
        readyToShoot=false;
        isRefilling = false;
        ammoCount -= 3;

        var reloadBufferFactor;
        if(ammoCount < 3)
            reloadBufferFactor = 2.5;
        else
            reloadBufferFactor = 1;

        alarm[0] = refireTime / global.delta_factor;
        alarm[5] = reloadBuffer*reloadBufferFactor / global.delta_factor;

        if (global.particles == PARTICLES_NORMAL)
        {
            var shell;
            shell = instance_create(x, y-10, Shell);
            shell.direction = owner.aimDirection + (140 - random(40)) * image_xscale;
        }
    }
");

object_event_add(TITAN.TitanGun, ev_other, ev_user2, "
    if(readyToShoot and global.isHost and ammoCount >= maxAmmo)
    {
        var seed;
        seed = irandom(65535);
        sendEventFireWeapon(ownerPlayer, seed);
        doEventFireWeapon(ownerPlayer, seed);
    }
");

object_event_add(TITAN.TitanGun, ev_other, ev_user3, "
    playsound(x,y,SniperSnd);
    shot=true;
    justShot=true;
    readyToShoot = false;
    ammoCount = 0;
    mode = 1;
    alarm[0] = (reloadTime2) / global.delta_factor;
    alarm[5] = reloadBuffer / global.delta_factor;
    alarm[7] = (reloadTime2/4) / global.delta_factor;  // Eject a shell during the animation

    // self damage
    damageCharacter(ownerPlayer, ownerPlayer.object, selfDamage);
    ownerPlayer.object.alarm[3] = ASSIST_TIME;
    ownerPlayer.object.lastDamageSource = DAMAGE_SOURCE_RIFLE;

    with(ownerPlayer.object) {
        motion_add(aimDirection, -6);
        vspeed -= 2;
    }

    // for drawing:
    tracerAlpha = 0.8;
    shotx = x + lengthdir_x(14, image_angle+90);
    shoty = y + lengthdir_y(14, image_angle+90);

    var hit;
    var x1,y1,xm,ym, len, bulletWall;
    var hitline;
    len=2000;
    x1=shotx;
    y1=shoty;
    x2=x1+lengthdir_x(len,owner.aimDirection);
    y2=y1+lengthdir_y(len,owner.aimDirection);

    gunSetSolids();
    alarm[6] = alarm[0];
    while(len>1) {
        xm=(x1+x2)/2;
        ym=(y1+y2)/2;

        hitline = false;
        with(owner) {
            if(collision_line(x1,y1,xm,ym,Obstacle,true,true)>=0) {
                hitline = true;
            }else if (collision_line(x1,y1,xm,ym,TeamGate,true,true)>=0) {
                hitline = true;
            } else if (collision_line(x1,y1,xm,ym,IntelGate,true,true)>=0) {
                hitline = true;
            } else if (collision_line(x1,y1,xm,ym,ControlPointSetupGate,true,true)>=0) if (ControlPointSetupGate.solid) {
                hitline = true;
            }
            bulletWall = collision_line(x1,y1,xm,ym,BulletWall,true,true);
            if (bulletWall>=0)
                if (bulletWall.solid)
                    hitline = true;
        }

        if(hitline) {
            x2=xm;
            y2=ym;
        } else {
            x1=xm;
            y1=ym;
        }
        len/=2;
    }

    with(Player) {
        if(id != other.ownerPlayer and team != other.owner.team and object != -1) {
            if (collision_line(other.shotx, other.shoty ,other.x2,other.y2,object,true,false) >= 0 and !object.ubered) {
                damageCharacter(other.ownerPlayer, object, other.hitDamage);
                if (object.lastDamageDealer != other.ownerPlayer && object.lastDamageDealer != object.player)
                {
                    object.secondToLastDamageDealer = object.lastDamageDealer;
                    object.alarm[4] = object.alarm[3]
                }
                object.alarm[3] = ASSIST_TIME;
                object.lastDamageDealer = other.ownerPlayer;
                object.cloakAlpha = max(object.cloakAlpha, 0.3);
                object.cloakFlicker = true;
                object.alarm[7] = 3;
                if(global.gibLevel > 0)
                {
                    blood = instance_create(object.x,object.y,Blood);
                    blood.direction = other.owner.aimDirection-180;
                }
                if (!other.owner.zoomed)
                    object.lastDamageSource = DAMAGE_SOURCE_RIFLE;
                else
                    object.lastDamageSource = DAMAGE_SOURCE_RIFLE_CHARGED;
            }
        }
    }

    with(Sentry) {
        if(team != other.owner.team) {
            if(collision_line(other.shotx, other.shoty, other.x2,other.y2,id,false,false)>=0) {
                damageSentry(other.ownerPlayer, id, other.hitDamage);
                lastDamageDealer = other.ownerPlayer;
                if (!other.owner.zoomed)
                    lastDamageSource = DAMAGE_SOURCE_RIFLE;
                else
                    lastDamageSource = DAMAGE_SOURCE_RIFLE_CHARGED;
            }
        }
    }

    with(Generator) {
        if(team != other.owner.team) {
            if(collision_line(other.shotx, other.shotx, other.x2,other.y2,id,true,false)>=0) {
                damageGenerator(other.ownerPlayer, id, other.hitDamage);
            }
        }
    }
    gunUnsetSolids();
");

object_event_add(TITAN.TitanGun, ev_draw, 0, "
    if (tracerAlpha > 0.05)
    {
        shot = false;
        var origdepth;
        origdepth = depth;
        depth = -2;

        draw_set_alpha(tracerAlpha);
        if(owner.team == TEAM_RED) {
            draw_line_width_color(shotx,shoty,x2,y2,10,c_red,c_red);
            draw_line_width_color(shotx,shoty,x2,y2,3,c_orange,c_orange);
        } else {
            draw_line_width_color(shotx,shoty,x2,y2,10,c_blue,c_blue);
            draw_line_width_color(shotx,shoty,x2,y2,3,c_aqua,c_aqua);
        }
        if(global.particles != PARTICLES_OFF)
            tracerAlpha /= delta_mult(1.75);
        else tracerAlpha = 0;

        draw_set_alpha(1);
        depth = origdepth;
    }
    else
        tracerAlpha = 0;

    var imageOffset, xdrawpos, ydrawpos;
    imageOffset = owner.team;
    xdrawpos = round(x+xoffset*image_xscale);
    ydrawpos = round(y+yoffset);
    if (alarm[6] <= 0){
        //set the sprite to idle
        imageOffset = owner.team;
    }else{
        //We are shooting, loop the shoot animation
        imageOffset = floor(image_index mod recoilAnimLength) + recoilAnimLength*owner.team
    }
        draw_sprite_ext(sprite_index,imageOffset,round(x+xoffset*image_xscale),round(y+yoffset),image_xscale,image_yscale,image_angle,c_white,image_alpha);
    if (owner.ubered) {
        if owner.team == TEAM_RED
            ubercolour = c_red;
        else if owner.team == TEAM_BLUE
            ubercolour = c_blue;
        draw_sprite_ext(sprite_index,imageOffset,round(x+xoffset*image_xscale),round(y+yoffset),image_xscale,image_yscale,image_angle,ubercolour,0.7*image_alpha);
    }
");

// Simulate the original weapons to prevent clients from locking up
object_event_add(TITAN.TitanGun, ev_other, ev_user12, "
    switch(ownerPlayer.class) {
        case CLASS_MEDIC:
            write_ubyte(global.serializeBuffer, 255);
        break;
        case CLASS_DEMOMAN:
            event_inherited();
            write_ubyte(global.serializeBuffer, 0);
        break;
        default:
            event_inherited();
        break;
    }
");

object_event_add(TITAN.TitanGun, ev_other, ev_user13, "
    switch(ownerPlayer.class) {
        case CLASS_MEDIC:
            receiveCompleteMessage(global.serverSocket, 1, global.deserializeBuffer);
            read_ubyte(global.deserializeBuffer);
        break;
        case CLASS_DEMOMAN:
            event_inherited();
            receiveCompleteMessage(global.serverSocket, 1, global.deserializeBuffer);
            read_ubyte(global.deserializeBuffer);
        break;
        default:
            event_inherited();
        break;
    }
");

// Don't allow healing
object_event_add(Medigun, ev_other, ev_user1, "
    if (healTarget != noone) {
        if (healTarget.object.isTitan) {
            healedThisStep = false;

            var healthGained;
            healthGained = healAmount * calculateHealingFactor(healTarget.object.timeUnscathed);
            if(healTarget.object.hp > healTierHealth)
                healthGained *= healTierAmount;

            if (healTarget.object.hp < healTarget.object.maxHp)
                healTarget.object.hp -= healthGained * global.delta_factor;

            hphealed -= healthGained * global.delta_factor;
            ownerPlayer.stats[HEALING] -= healthGained * global.delta_factor;
            ownerPlayer.roundStats[HEALING] -= healthGained * global.delta_factor;

            if(ubering == false && uberCharge<2000) {
                var setup;
                setup = false;
                if instance_exists(ControlPointSetupGate) {
                    if (ControlPointSetupGate.solid)
                        setup = true;
                }
                if(healTarget.object.hp < healTarget.object.maxHp or setup)
                    uberCharge -= 2.5 * global.delta_factor;
                else
                    uberCharge -= 1.75 * global.delta_factor;
            }

            sound_stop(MedigunSnd);
            healTarget = noone;
        }
    }
");

// TITAN
TITAN.Titan = object_add();
object_set_parent(TITAN.Titan, Sentry);
object_set_mask(TITAN.Titan, TITAN.TitanMaskS);
object_set_depth(TITAN.Titan, 1);

object_event_add(TITAN.Titan, ev_create, 0, "
    image_speed = 0;
    team = TEAM_RED;
    maxHp = 100;
    hp = 100;
    prevHp = hp;
    isTitan = true;

    lastDamageDealer = noone;
    lastDamageSource = -1;
    ownerPlayer = -1;

    countdown = false;
    staticIdx = 0;
    countdownIdx = 0;

    colliding = true;
    ubered = false;
    canBoard = false;
    alarm[2] = 10 / global.delta_factor;
    built = true;
");

object_event_add(TITAN.Titan, ev_destroy, 0, "
    // Allow the mines stickied to this titan to drop to the floor
    with(Mine)
    {
        if(place_meeting(x,y,other.id))
            stickied = false;
    }
");

object_event_add(TITAN.Titan, ev_alarm, 2, "
    canBoard = true;
");

object_event_add(TITAN.Titan, ev_step, ev_step_begin, "
    if (colliding) {
        wallSetSolid();

        // Try to get outside of the wallmask if we're in it.
        if(!place_free(x, y))
            move_outside_solid(0, 6);
        if(!place_free(x, y))
            move_outside_solid(180, 12);
        if(!place_free(x, y))
        {
            move_outside_solid(0, 6);
            move_outside_solid(90, 100);
        }

        if(place_free(x+hspeed, y+vspeed+0.6))
            vspeed += 0.6  * global.delta_factor;
        if(!place_free(x+hspeed, y+vspeed) and place_free(x, y))
            event_user(2);

        if(vspeed > 10)
            vspeed = 10;

        wallUnsetSolid();
    }

    hspeed = 0;
    y += vspeed * global.delta_factor;
    y -= vspeed;

    if (countdown) {
        countdownIdx = (countdownIdx + 0.15 * global.delta_factor);
        if (countdownIdx >= 18) {
            hp = -999;
        }
    }

    staticIdx = (staticIdx + 0.15 * global.delta_factor) mod 6;
");

object_event_add(TITAN.Titan, ev_step, ev_step_end, "
    if(global.isHost and hp <= 0)
    {
        var buffer;
        buffer = buffer_create();
        write_ubyte(buffer, TITAN.EXPLODE);
        write_ubyte(buffer, ds_list_find_index(TITAN.list, id));
        PluginPacketSend(TITAN.packetID, buffer, true);
        buffer_destroy(buffer);
        exit;
    }

    if(hp > maxHp) hp=maxHp;
");

object_event_add(TITAN.Titan, ev_draw, 0, "
    var xr, yr;
    xr = round(x);
    yr = round(y);

    draw_sprite_ext(TITAN.TitanBottomS, team, xr, yr, image_xscale, image_yscale, 0, c_white, 1);
    draw_sprite_ext(TITAN.TitanFrameS,  team*3 + 2 - round(hp/50), xr, yr, image_xscale, image_yscale, 0, c_white, 1);
    draw_sprite_ext(TITAN.TitanArmDownS, team, xr - 28*image_xscale, yr - 46, image_xscale, image_yscale, 0, c_white, 1);

    if (countdown) {
        draw_sprite_ext(TITAN.CountdownWindowS, countdownIdx, xr - 16*image_xscale, yr - 56, image_xscale, image_yscale, 0, c_white, 1);
    } else if (hp < 20) {
        draw_sprite_ext(TITAN.StaticWindowS, staticIdx, xr - 16*image_xscale, yr - 56, image_xscale, image_yscale, 0, c_white, 1);
    } else {
        draw_sprite_ext(TITAN.ClassWindowS, 19, xr - 16*image_xscale, yr - 56, image_xscale, image_yscale, 0, c_white, 1);
    }

    if global.myself.team == team draw_healthbar(xr - 10, yr - 80, xr + 10, yr - 85, hp*100/maxHp, c_black, c_red, c_green, 0, true, true);
");

object_event_add(TITAN.Titan, ev_other, ev_user1, "
    // nope
");

// TITANSPAWNER
TITAN.TitanSpawner = object_add();
object_set_visible(TITAN.TitanSpawner, false);

object_event_add(TITAN.TitanSpawner, ev_create, 0, "
    delay = 0;
    repeat_speed = 0;
    myTitan = noone;
    team = TEAM_RED;
    image_xscale = 1;
");

object_event_add(TITAN.TitanSpawner, ev_alarm, 0, "
    if (repeat_speed > 0) {
        alarm[0] = repeat_speed;
    }

    if (myTitan == noone || !instance_exists(myTitan)) {
        myTitan = instance_create(x, y, TITAN.Titan);
        myTitan.image_xscale = image_xscale;
        myTitan.team = team;
        playsound(x, y, RespawnSnd);

        var buffer;
        buffer = buffer_create();
        write_ubyte(buffer, TITAN.SPAWN);
        write_ushort(buffer, x*5);
        write_ushort(buffer, y*5);
        write_byte(buffer, image_xscale);
        write_ubyte(buffer, 100);
        write_ubyte(buffer, team);
        PluginPacketSend(TITAN.packetID, buffer, false);
        buffer_destroy(buffer);
        ds_list_add(TITAN.list, myTitan);
    }
");

object_event_add(TITAN.TitanSpawner, ev_other, ev_user1, "
    delay = readProperty(other.properties, 'delay', REAL, delay) * 30 / global.delta_factor;
    repeat_speed = readProperty(other.properties, 'repeat', REAL, repeat_speed) * 30 / global.delta_factor;

    if (global.isHost)
        alarm[0] = max(1, delay);
");

// TITANSPAWNER BLUE
TITAN.TitanSpawnerBlue = object_add();
object_set_visible(TITAN.TitanSpawnerBlue, false);
object_set_parent(TITAN.TitanSpawnerBlue, TITAN.TitanSpawner);

object_event_add(TITAN.TitanSpawnerBlue, ev_create, 0, "
    event_inherited();
    team = TEAM_BLUE;
    image_xscale = -1;
");

// ANIMATED TITANDEADBODY
TITAN.DeadTitan = object_add();
object_set_parent(TITAN.DeadTitan, DeadGuy);
object_set_depth(TITAN.DeadTitan, 1);
object_set_mask(TITAN.DeadTitan, TITAN.DeadTitanMaskS);

object_event_add(TITAN.DeadTitan, ev_step, ev_step_begin, "
    if (round(image_index) >= endFrame || round(image_index) < startFrame) {
        var body;
        body = instance_create(x, y+1, DeadGuy);
        if (team == TEAM_RED) {
            body.sprite_index = TITAN.DeadRedTitanS;
        } else {
            body.sprite_index = TITAN.DeadBlueTitanS;
        }

        body.image_speed = 0.25 * global.delta_factor;
        body.image_xscale = image_xscale;

        instance_destroy();
    }
");

// Make the entities spawn the right thing even if they were preloaded by the garrison builder extension plugin.
ds_map_replace(ds_list_find_value(global.entityData, addEntity("titan_red", -1, "{delay:0, repeat:0}", -1, -1, -1, -1, -1, "")), "object", TITAN.TitanSpawner);
ds_map_replace(ds_list_find_value(global.entityData, addEntity("titan_blue", -1, "{delay:0, repeat:0}", -1, -1, -1, -1, -1, "")), "object", TITAN.TitanSpawnerBlue);

// HUD
TITAN.TitanHud = object_add();
object_set_depth(TITAN.TitanHud, -110000);

object_event_add(TITAN.TitanHud, ev_step, ev_step_end, "
    // Hide normal huds
    if(global.myself.object == -1) {
        exit;
    }

    if (global.myself.object.isTitan) {
        AmmoCounter.visible = false;
        HealthHud.visible = false;
    } else {
        AmmoCounter.visible = true;
        HealthHud.visible = true;
    }
");

object_event_add(TITAN.TitanHud, ev_draw, 0, "
    // BEHOLD THE POWER OF COPY-PASTING
    if(global.myself.object == -1) {
        instance_destroy();
        exit;
    }

    xsize = view_wview[0];
    ysize = view_hview[0];
    xoffset = view_xview[0];
    yoffset = view_yview[0];
    draw_set_valign(fa_center);
    draw_set_halign(fa_center);
    draw_set_alpha(1);

    if (global.myself.object.isTitan) {
        drawHealth(45, ysize-53, global.myself.object.hp*10, global.myself.object.maxHp*10);
        draw_sprite_ext(CharacterHUD, 10*global.myself.team, view_xview[0]+5, view_yview[0]+ysize-75, 2, 2, 0, c_white, 1);
        draw_sprite_ext(TITAN.ClassWindowS, global.myself.class + 10*global.myself.team, view_xview[0]-19, view_yview[0]+ysize-67, 2, 2, 0, c_white, 1);

        draw_healthbar(xoffset+xsize-135, yoffset+ysize-49, xoffset+xsize-15, yoffset+ysize-17,round(global.myself.object.currentWeapon.ammoCount/global.myself.object.currentWeapon.maxAmmo*100),c_black,c_white,c_white,0,true,true);
        draw_sprite_ext(UberHudS,global.myself.team,xoffset+xsize-80,yoffset+ysize-34,2,2,0,c_white,1);
        draw_text_color(xoffset+xsize-70,yoffset+ysize-39,'POWER',c_white,c_white,c_white,c_white,1);
    }
");

// NETWORKING
object_event_add(PlayerControl, ev_step, ev_step_begin, "
    if (keyboard_check_pressed(TITAN.BoardingButton) && global.myself.object != -1 && instance_exists(global.myself.object)) {
        var buffer;
        buffer = buffer_create();
        write_ubyte(buffer, TITAN.KEYPRESS);
        PluginPacketSend(TITAN.packetID, buffer, true);
        buffer_destroy(buffer);
    }

    var player;
    while(PluginPacketGetBuffer(TITAN.packetID) != -1) {
        receiveBuffer = PluginPacketGetBuffer(TITAN.packetID);
        switch(read_ubyte(receiveBuffer)) {
            case TITAN.KEYPRESS:
               if (global.isHost) {
                   player = PluginPacketGetPlayer(TITAN.packetID);
                   if (player.object != -1 && instance_exists(player.object)) {
                       var buffer;
                       buffer = buffer_create();
                       if (!player.object.isTitan) {
                            with(TITAN.Titan) {
                                if (point_distance(player.object.x, player.object.y, x, y) < 64 && team == player.team && canBoard) {
                                    write_ubyte(buffer, TITAN.MOUNT);
                                    write_ubyte(buffer, ds_list_find_index(TITAN.list, id));
                                    write_ubyte(buffer, ds_list_find_index(global.players, player));
                                    PluginPacketSend(TITAN.packetID, buffer, true);
                                    break;
                                }
                            }
                       } else {
                            write_ubyte(buffer, TITAN.DISMOUNT);
                            write_ubyte(buffer, ds_list_find_index(global.players, player));
                            PluginPacketSend(TITAN.packetID, buffer, true);
                       }
                       buffer_destroy(buffer);
                   }
               }
           break;
           case TITAN.MOUNT:
               var player, titan, pos;
               pos = read_ubyte(receiveBuffer);
               titan = ds_list_find_value(TITAN.list, pos);
               player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
               ds_list_delete(TITAN.list, pos);

               with(titan) {
                   player.object.x = x;
                   player.object.y = y;
                   execute_string(TITAN.titanize, player.object, hp);
                   playsound(x, y, SentryBuildSnd);
                   instance_destroy();
               }
           break;
           case TITAN.DISMOUNT:
               player = ds_list_find_value(global.players, read_ubyte(receiveBuffer));
               with(player.object) {
                   if (isTitan) {
                       var titan;
                       titan = instance_create(x, y, TITAN.Titan);
                       titan.image_xscale = image_xscale;
                       titan.hp = hp;
                       titan.vspeed = vspeed;
                       titan.hspeed = hspeed;
                       titan.team = player.team;
                       titan.countdown = true;

                       execute_string(TITAN.detitanize, id);
                       ds_list_add(TITAN.list, titan);

                       vspeed -= 10;
                       playsound(x, y, JumpSnd);
                   }
               }
            break;
            case TITAN.EXPLODE:
                var pos;
                pos = read_ubyte(receiveBuffer);
                execute_string(TITAN.destroyTitan, ds_list_find_value(TITAN.list, pos));

                with(ds_list_find_value(TITAN.list, pos)) {
                    instance_destroy();
                }
                ds_list_delete(TITAN.list, pos);
            break;
            case TITAN.SPAWN:
                var titan;
                titan = instance_create(read_ushort(receiveBuffer)/5, read_ushort(receiveBuffer)/5, TITAN.Titan);
                titan.image_xscale = read_byte(receiveBuffer);
                titan.hp = read_ubyte(receiveBuffer);
                titan.team = read_ubyte(receiveBuffer);
                playsound(titan.x, titan.y, RespawnSnd);
                ds_list_add(TITAN.list, titan);
            break;
        }
        PluginPacketPop(TITAN.packetID);
    }
");
